studentdb/config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  devise_for :users
  get 'site/index'
  get 'site/admin_dashboard', as: :admin_dashboard
  resources :projects
  resources :students
  post 'projects/:id/students', as: :add_student_to_project, controller: :projects, action: :add_student
  root to: 'site#index'
end

studentdb/app/models/student.rb
# frozen_string_literal: true

# Model class for student records
class Student < ApplicationRecord
  has_many :project_students, dependent: :destroy
  has_many :projects, through: :project_students
  validates_presence_of :name
  validates_presence_of :studentid
  validates_uniqueness_of :studentid
  accepts_nested_attributes_for :projects, allow_destroy: true, reject_if: :reject_projects
  attr_accessor :_destroy_r

  def reject_projects(attributes)
    attributes['name'].blank? and attributes['url'].blank?
  end

  def self.find_or_create_by_studentid(studentid)
    student = find_by_studentid(studentid)
    student || create(studentid: studentid, name: 'New student')
  end
end

studentdb/app/controllers/students_controller.rb
# frozen_string_literal: true

# Student controller class
class StudentsController < ApplicationController
  before_action :set_student, only: %i[show edit update destroy]

  # GET /students or /students.json
  def index
    @students = Student.all
  end

  # GET /students/1 or /students/1.json
  def show; end

  # GET /students/new
  def new
    @student = Student.new
    @student.projects.build
  end

  # GET /students/1/edit
  def edit
    @student.projects.build
  end

  # POST /students or /students.json
  def create
    @student = Student.create(student_params)
    respond_to do |format|
      if @student.id
        format.html { redirect_to @student, notice: 'Student was successfully created.' }
        format.json { render :show, status: :created, location: @student }
      else
        format.html { render :new }
        format.json { render json: @student.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /students/1 or /students/1.json
  def update
    respond_to do |format|
      if @student.update(student_params)
        format.html { redirect_to @student, notice: 'Student was successfully updated.' }
        format.json { render :show, status: :ok, location: @student }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @student.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /students/1 or /students/1.json
  def destroy
    @student.destroy
    respond_to do |format|
      format.html { redirect_to students_url, notice: 'Student was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_student
    @student = Student.find(params[:id])
  end

  # Get list of IDs from projects attributes
  def existing_project_ids(filtered_parms)
    filtered_parms[:projects_attributes]&.values&.collect { |p| p[:id] }&.compact
  end

  # Only allow a list of trusted parameters through.
  def student_params
    filtered_params = params.require(:student).permit(
      :studentid, :name, project_ids: [], projects_attributes: %i[id name url _destroy]
    )
    filtered_params[:project_ids] |= existing_project_ids(filtered_params)
    filtered_params
  end
end

studentdb/app/helpers/students_helper.rb
# frozen_string_literal: true

# Helper module for student views
module StudentsHelper
end

studentdb/app/views/students/_form.html.erb
<%= form_with(model: student, local: true, class: 'row d-flex justify-content-center') do |form| %>
  <% if student.errors.any? %>
    <div id="error_explanation" class="mb-4 text-center">
      <h2><%= pluralize(student.errors.count, "error") %> prohibited this student from being saved:</h2>
      <ul>
        <% student.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-outline mb-4">
    <%= form.text_field :studentid, class: 'form-control' %>
    <%= form.label :studentid, class: 'form-label' %>
  </div>

  <div class="form-outline mb-4">
    <%= form.text_field :name, class: 'form-control' %>
    <%= form.label :name, class: 'form-label' %>
  </div>

  <%= form.submit class: 'btn btn-primary mb-4' %>

  <% if !student.new_record? %>
    <h5>Projects</h5>
      <div id="existing-projects-container" class="mb-4">
      <%= form.select :project_ids,
          options_for_select((Project.all - student.projects).collect { |project| [project.name, project.id] }),
          {}, { multiple: true, id: "existing-projects" } %>
    </div>


    <%= form.fields_for(:projects) do |nested_form| %>
      <% if nested_form.object.new_record? %>
        <p class="mb-4">
          <%= link_to 'Add new project', '#new-project-form',
                      class: 'btn',
                      'data-mdb-toggle' => 'collapse',
                      role: 'button',
                      'aria-expanded' => 'false',
                      'aria-controls' => 'new-project-form' %>
        </p>
        <div class="collapse mt-3" id="new-project-form">
          <h6>New project</h6>
      <% else %>
        <% project_index = nested_form.options[:child_index] %>
        <div class="mt-3" id="project-<%= project_index %>-form">
          <h6>Current project
            <%= nested_form.check_box :_destroy, value: false, style: "display: none;" %>
            <%= link_to '#', class: "destroy-project-link", data: { project_index: project_index } do %>
              <span title="Remove project from student"><i class="fa fa-folder-minus"></i></span>
            <% end %>
          </h6>
      <% end %>
          <div class="form-outline mb-4">
            <%= nested_form.text_field :name, class: 'form-control' %>
            <%= nested_form.label :name, class: 'form-label' %>
          </div>
          <div class="form-outline mb-4">
            <%= nested_form.text_field :url, class: 'form-control' %>
            <%= nested_form.label :url, class: 'form-label' %>
          </div>
        </div>
    <% end %>
    <%= form.submit 'Update student projects', class: 'btn btn-primary mb-4' %>
  <% end %>
<% end %>

studentdb/app/views/students/edit.html.erb
<div class="col-md-4 offset-md-4">
  <div class="card">
    <div class="card-body">
      <h4 class="card-title">
        Edit Student
        <%= link_to student_path(@student) do %>
          <span title="Discard changes and show"><i class="fa fa-eye"></i></span>
        <% end %>
      </h4>
      <%= link_to students_path do %>
        <h4 class="close"><span title="Close"><i class="fa fa-times"></i></span></h4>
      <% end %>
      <%= render 'form', student: @student %>
    </div>
  </div>
</div>

studentdb/app/views/students/index.html.erb
<div class="col-md-4 offset-md-4">
  <div class="card">
    <div class="card-body">
      <h4 class="card-title">Students</h4>
      <table class="table table-striped">
        <thead>
          <tr>
            <th>Studentid</th>
            <th>Name</th>
            <% if user_signed_in? %>
              <th colspan="3">Actions</th>
            <% else %>
              <th colspan="1"></th>
            <% end %>
          </tr>
        </thead>

        <tbody>
          <% @students.each do |student| %>
            <tr>
              <td><%= student.studentid %></td>
              <td><%= student.name %></td>
              <td>
                <%= link_to student do %>
                  <i class="fa fa-eye"></i>
                <% end %>
              </td>
              <% if user_signed_in? %>
                <td>
                  <%= link_to edit_student_path(student) do %>
                    <i class="fa fa-edit"></i>
                  <% end %>
                </td>
                <td>
                  <%= link_to student, method: :delete, data: { confirm: 'Are you sure?' } do %>
                    <i class="fa fa-trash"></i>
                  <% end %>
                </td>
              <% end %>
            </tr>
          <% end %>
        </tbody>
      </table>
      <% if user_signed_in? %>
        <%= link_to 'New Student', new_student_path, class: "btn btn-primary", role: "button" %>
      <% end %>
    </div>
  </div>
</div>

studentdb/app/views/students/new.html.erb
<div class="col-md-4 offset-md-4">
  <div class="card">
    <div class="card-body">
      <h4 class="card-title">New Student</h4>
      <%= link_to students_path do %>
        <h4 class="close"><span title="Close"><i class="fa fa-times"></i></span></h4>
      <% end %>
      <%= render 'form', student: @student %>
    </div>
  </div>
</div>

studentdb/app/views/students/show.html.erb
<div class="col-md-4 offset-md-4">
  <div class="card">
    <div class="card-body">
      <h4 class="card-title">
        <%= @student.name %>
        <%= link_to edit_student_path(@student) do %>
          <span title="Edit"><i class="fa fa-edit"></i></span>
        <% end %>
      </h4>
      <%= link_to students_path do %>
        <h4 class="close"><span title="Close"><i class="fa fa-times"></i></span></h4>
      <% end %>
      <p class="mb-4"><strong>Student ID:</strong> <%= @student.studentid %></p>
      <h5>Projects</h5>
      <% if @student.projects.size > 0 %>
        <table class="table table-striped">
          <thead>
            <tr>
              <th>Name</th>
              <th>URL</th>
            </tr>
          </thead>
          <tbody>
            <% @student.projects.each do |project| %>
              <tr>
                <td><%= link_to project.name, project_path(project) %></td>
                <td><%= project.url %></td>
              </tr>
            <% end %>
          </tbody>
        </table>
      <% else %>
        <p class="mb-4"><i>None added yet</i></p>
      <% end %>
    </div>
  </div>
</div>